Loading...
Searching...
No Matches
CID10013_CTAcquisitionType Class Reference

Implementation of DCMR Context Group: CID 10013 - CT Acquisition Type. More...

Inheritance diagram for CID10013_CTAcquisitionType:

## Public Types

enum | EnumType { SequencedAcquisition , SpiralAcquisition , ConstantAngleAcquisition , StationaryAcquisition , FreeAcquisition , ConeBeamAcquisition }
| types of CT acquisition type More...

## Public Member Functions

| CID10013_CTAcquisitionType (const DSRCodedEntryValue &selectedValue=DSRCodedEntryValue())
| (default) constructor
| CID10013_CTAcquisitionType (const EnumType selectedValue, const OFBool enhancedEncodingMode=OFFalse)
| constructor
virtual OFCondition | selectValue (const EnumType selectedValue, const OFBool enhancedEncodingMode=OFFalse)
| select a coded entry given by its type as the current value
virtual OFCondition | selectValue (const DSRCodedEntryValue &codedEntryValue, const OFBool check=OFTrue, const OFBool definedContextGroup=OFFalse)
| select a given coded entry as the current value
virtual OFCondition | findCodedEntry (const DSRCodedEntryValue &codedEntryValue) const
| search for a given coded entry in this context group.
Public Member Functions inherited from DSRContextGroup
| operator const DSRCodedEntryValue & () const
| conversion operator that returns the currently selected coded entry value (might be empty if none is selected)
virtual void | clear ()
| clear list of extended coded entries and forget about the currently selected coded entry
OFBool | isExtensible () const
| check whether context group is extensible
void | setExtensible (const OFBool mode=OFTrue)
| change mode specifying whether the context group is extensible or non-extensible
const OFString & | getIdentifier () const
| get context identifier
const OFString & | getMappingResource () const
| get mapping resource
const OFString & | getKeyword () const
| get context group keyword
const OFString & | getVersion () const
| get context group version (optional)
const OFString & | getUID () const
| get context group UID (optional)
virtual OFBool | hasSelectedValue () const
| check whether a coded entry is selected as the current value
const DSRCodedEntryValue & | getSelectedValue () const
| get currently selected coded entry value (optional)
virtual OFBool | hasCodedEntry (const DSRCodedEntryValue &codedEntryValue) const
| check whether a given coded entry is contained in this context group.
virtual OFBool | hasExtendedCodedEntries () const
| check whether this context group has any extended coded entries.
virtual OFCondition | addCodedEntry (const DSRCodedEntryValue &codedEntryValue)
| add a coded entry to this context group as an extension, i.e. as a non-standard code.
virtual OFCondition | lookupCodedEntry (DSRCodedEntryValue &codedEntryValue, const OFBool enhancedEncodingMode=OFFalse) const
| search for a given coded entry in this context group and, if found, replace its value with the one found in the context group.
virtual void | print (STD_NAMESPACE ostream &stream) const
| print contents of this context group, i.e. a general header, the currently selected coded entry value (if any) and all coded entries that are contained in this context group (both standard and extended ones).
virtual OFCondition | checkSelectedValue (const OFBool definedContextGroup=OFFalse) const
| check whether the currently selected coded entry is valid.

## Static Public Member Functions

static void | initialize ()
| initialize this context group explicitly.
static void | cleanup ()
| cleanup this context group, i.e. delete the internal list of standard coded entries.
static DSRCodedEntryValue | getCodedEntry (const EnumType value, const OFBool enhancedEncodingMode=OFFalse)
| map a given type to the associated coded entry

## Protected Types

typedef OFMap< EnumType, DSRBasicCodedEntry > | CodeList
| type used for storing and managing the coded entries

## Protected Member Functions

virtual void | printCodes (STD_NAMESPACE ostream &stream) const
| print details on coded entries that are contained in this context group.
virtual OFCondition | findCodedEntry (const DSRCodedEntryValue &searchForCodedEntry, DSRCodedEntryValue *foundCodedEntry, const OFBool enhancedEncodingMode=OFFalse) const
| search for a given coded entry in this context group
Protected Member Functions inherited from DSRContextGroup
| DSRContextGroup (const OFString &contextIdentifier, const OFString &mappingResource, const OFString &contextGroupKeyword="", const OFString &contextGroupVersion="", const OFString &contextGroupUID="", const DSRCodedEntryValue &selectedValue=DSRCodedEntryValue())
| constructor
virtual | ~DSRContextGroup ()
| destructor
virtual void | printHeader (STD_NAMESPACE ostream &stream) const
| print header with some general information on this context group
virtual OFCondition | checkCodedEntry (const DSRCodedEntryValue &codedEntryValue, const OFBool definedContextGroup) const
| check whether a given coded entry is valid.

## Static Protected Member Functions

static CodeList & | getCodes ()
| get list of standard coded entries that are managed by this context group.
static OFCondition | setEnhancedEncodingMode (DSRCodedEntryValue &codedEntryValue)
| set the "Enhanced Encoding Mode" for a given coded entry

## Static Private Attributes

static CodeList * | Codes
| pointer to internal code list (use a static variable for singleton pattern)

## Detailed Description

Implementation of DCMR Context Group: CID 10013 - CT Acquisition Type.

(type: extensible, version: 20160314)

## Member Enumeration Documentation

## EnumType

enum CID10013_CTAcquisitionType::EnumType

types of CT acquisition type

Enumerator
SequencedAcquisition | (113804,DCM,"Sequenced Acquisition")
SpiralAcquisition | (116152004,SCT,"Spiral Acquisition")
ConstantAngleAcquisition | (113805,DCM,"Constant Angle Acquisition")
StationaryAcquisition | (113806,DCM,"Stationary Acquisition")
FreeAcquisition | (113807,DCM,"Free Acquisition")
ConeBeamAcquisition | (702569007,SCT,"Cone Beam Acquisition")

## Constructor & Destructor Documentation

## CID10013_CTAcquisitionType() [1/2]

CID10013_CTAcquisitionType::CID10013_CTAcquisitionType | ( | const DSRCodedEntryValue & | selectedValue = DSRCodedEntryValue() | ) |

(default) constructor

Parameters

  selectedValue | coded entry to be selected as the current value (optional). Should be a valid code according to the DICOM definitions for this context group, i.e. no checks are performed. Call DSRContextGroup::checkSelectedValue() if needed.

## CID10013_CTAcquisitionType() [2/2]

CID10013_CTAcquisitionType::CID10013_CTAcquisitionType | ( | const EnumType | selectedValue,
|  | const OFBool | enhancedEncodingMode = OFFalse )

constructor

Parameters

  selectedValue | type mapped to a coded entry that is selected as the current value
  enhancedEncodingMode | set enhanced encoding mode for coded entry (if enabled)

## Member Function Documentation

## cleanup()

void CID10013_CTAcquisitionType::cleanup | ( |  | ) |

static

cleanup this context group, i.e. delete the internal list of standard coded entries.

Usually, there is no need to call this method, but it might be useful in order to explicitly free the associated memory, e.g. when checking for memory leaks. The list will be recreated automatically when needed (or when initialize() is called).

## findCodedEntry() [1/2]

virtual OFCondition DSRContextGroup::findCodedEntry | ( | const DSRCodedEntryValue & | codedEntryValue | ) | const

virtual

search for a given coded entry in this context group.

If found, the type of the entry (standard or extension) is returned:

- SR_EC_CodedEntryInStandardContextGroup
- SR_EC_CodedEntryIsExtensionOfContextGroup

Parameters

  codedEntryValue | coded entry to be searched for

Returns
  result of the search process, SR_EC_CodedEntryNotInContextGroup if coded entry could not be found. Use OFCondition::good() or OFCondition::bad() if not interested in the type of the entry.

Reimplemented from DSRContextGroup.

## findCodedEntry() [2/2]

virtual OFCondition CID10013_CTAcquisitionType::findCodedEntry | ( | const DSRCodedEntryValue & | searchForCodedEntry,
|  | DSRCodedEntryValue * | foundCodedEntry,
|  | const OFBool | enhancedEncodingMode = OFFalse ) const

protected virtual

search for a given coded entry in this context group

Parameters

  searchForCodedEntry | coded entry to be searched for
  foundCodedEntry | pointer to variable that will store the coded entry (if found and pointer is not NULL)
  enhancedEncodingMode | set enhanced encoding mode for coded entry (if enabled)

Returns
  result of the search process, also defines the type of the entry

Reimplemented from DSRContextGroup.

## getCodedEntry()

DSRCodedEntryValue CID10013_CTAcquisitionType::getCodedEntry | ( | const EnumType | value,
|  | const OFBool | enhancedEncodingMode = OFFalse )

static

map a given type to the associated coded entry

Parameters

  value | type that should be mapped to a coded entry
  enhancedEncodingMode | set enhanced encoding mode for coded entry (if enabled)

Returns
  coded entry that is associated with the given type

References DSRContextGroup::findCodedEntry(), and DSRContextGroup::selectValue().

## getCodes()

CodeList & CID10013_CTAcquisitionType::getCodes | ( |  | ) |

static protected

get list of standard coded entries that are managed by this context group.

Internally, the singleton pattern is used, so the list is initialized only once. Please note that this function is not thread-safe. Therefore, the initialize() function can be called before any instance of this class is actually used.

Returns
  reference to list of coded entries managed by this context group

## initialize()

void CID10013_CTAcquisitionType::initialize | ( |  | ) |

static

initialize this context group explicitly.

Internally, the list of standard coded entries is created and initialized by calling getCodes().

Note
  This function can be called multiple times but in case of multi-threaded applications should be called at least once before any instance of this class is actually used. For single-threaded applications, there is no need to call it since the initialization is done implicitly.

## printCodes()

virtual void CID10013_CTAcquisitionType::printCodes | ( | STD_NAMESPACE ostream & | stream | ) | const

protected virtual

print details on coded entries that are contained in this context group.

See DSRCodedEntryValue::print() for details of the coded entry output.

Parameters

  stream | stream to which the output should be printed

Reimplemented from DSRContextGroup.

## selectValue() [1/2]

virtual OFCondition DSRContextGroup::selectValue | ( | const DSRCodedEntryValue & | codedEntryValue,
|  | const OFBool | check = OFTrue,
|  | const OFBool | definedContextGroup = OFFalse )

virtual

select a given coded entry as the current value

Parameters

  codedEntryValue | coded entry to be selected as the current value
  check | if enabled, check 'codedEntryValue' for validity and appropriateness before selecting it as the current value. See checkSelectedValue() for details.
  definedContextGroup | flag indicating whether this context group is used as a baseline (default) or defined context group. The first means that the list of coded entries in this context group is just a suggestion. The latter means that one of the coded entries should be used.

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DSRContextGroup.

Reimplemented in CID10013e_CTAcquisitionType.

## selectValue() [2/2]

virtual OFCondition CID10013_CTAcquisitionType::selectValue | ( | const EnumType | selectedValue,
|  | const OFBool | enhancedEncodingMode = OFFalse )

virtual

select a coded entry given by its type as the current value

Parameters

  selectedValue | type mapped to a coded entry that is selected as the current value
  enhancedEncodingMode | set enhanced encoding mode for coded entry (if enabled)

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented in CID10013e_CTAcquisitionType.

Referenced by CID10013e_CTAcquisitionType::mapAcquisitionType().

## setEnhancedEncodingMode()

OFCondition CID10013_CTAcquisitionType::setEnhancedEncodingMode | ( | DSRCodedEntryValue & | codedEntryValue | ) |

static protected

set the "Enhanced Encoding Mode" for a given coded entry

Parameters

  codedEntryValue | coded entry for which the enhanced encoding mode is set

Returns
  status, EC_Normal if successful, an error code otherwise

The documentation for this class was generated from the following file:

- dcmsr/include/dcmtk/dcmsr/cmr/cid10013.h

Generated on for DCMTK Version 3.7.0 by Doxygen 1.15.0